package net.pingex.dcf.commands;

import sx.blah.discord.api.IDiscordClient;
import sx.blah.discord.handle.obj.IMessage;
import java.util.List;

/**
 * A Context contains all informations related to a command invocation, like the Command being invoked, its provided arguments and the originating message.
 */
public class Context
{
	/**
	 * The command being executed
	 */
	private Command command;

	/**
	 * Arguments provided
	 */
	private List<String> arguments;

	/**
	 * The originating reference message
	 */
	private IMessage originatingMessage;

	/**
	 * Discord client for context
	 */
	private IDiscordClient client;

	public Context(Command command, List<String> arguments, IMessage originatingMessage, IDiscordClient client)
	{
		this.command = command;
		this.arguments = arguments;
		this.originatingMessage = originatingMessage;
		this.client = client;
	}

	public Command getCommand()
	{
		return command;
	}

	public List<String> getArguments()
	{
		return arguments;
	}

	public IMessage getOriginatingMessage()
	{
		return originatingMessage;
	}

	public IDiscordClient getClient()
	{
		return client;
	}
}
